package cn.iocoder.yudao.module.member.service.activitypay;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.member.controller.admin.activitypay.vo.*;
import cn.iocoder.yudao.module.member.controller.app.activity.vo.AppActivityPayRespVO;
import cn.iocoder.yudao.module.member.controller.app.activity.vo.AppCancelVO;
import cn.iocoder.yudao.module.member.dal.dataobject.activitypay.ActivityPayDO;

import javax.validation.Valid;
import java.time.LocalDate;
import java.util.List;
import java.util.Map;

/**
 * 活动付款 Service 接口
 *
 * @author 我是秦俊旗
 */
public interface ActivityPayService {

    /**
     * 创建活动付款
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createActivityPay(@Valid ActivityPaySaveReqVO createReqVO);

    /**
     * 更新活动付款
     *
     * @param updateReqVO 更新信息
     */
    void updateActivityPay(@Valid ActivityPaySaveReqVO updateReqVO);

    /**
     * 删除活动付款
     *
     * @param id 编号
     */
    void deleteActivityPay(Long id);

    /**
     * 获得活动付款
     *
     * @param id 编号
     * @return 活动付款
     */
    ActivityPayDO getActivityPay(Long id);

    /**
     * 获得活动付款分页
     *
     * @param pageReqVO 分页查询
     * @return 活动付款分页
     */
    PageResult<ActivityPayDO> getActivityPayPage(ActivityPayPageReqVO pageReqVO);

    Map<Long, ActivityPayCountVO> countByActivityIds(List<Long> activityIds);

    void addActivityPay(ActivityPaySaveReqVO createReqVO);

    PageResult<AppActivityPayRespVO> getUserActivityPayPage(ActivityPayPageReqVO pageReqVO);

    PageResult<AppActivityPayRespVO> getMerchantActivityPayPage(ActivityPayPageReqVO pageReqVO);

    Boolean reserveCancel(AppCancelVO vo);

    List<ActivityPayDO>  getListByTime();

    void updateBatch(List<ActivityPayDO> list);

    void insertOne(ActivityPayDO activityPayDO);

    ActivityPayDO getOneByActivityIdAndTimeAndNum(Long activityId, LocalDate time, Integer num);

    void updateOne(ActivityPayDO activityPayDO );

    PageResult<ActivityPayPageRVO> getPage(ActivityPayPageVO pageVO);
}